/*
*   Hot air controller
*   Controller for a hot air soldering gun
*
*   File: displaymanagement.c
*
*   Version:    1.0 beta (06.03.2011)
*   Author:     Tobias Schlegel, DK7SCH
*   Web:        www.tobias-schlegel.de
*   Contact:    tobias@drschlegel.de
*   Date:       06.03.2011
*   License:    Creative Commons CC-BY 3.0
*               http://creativecommons.org/licenses/by/3.0/deed.en
*
*               Attribution:    Attribute with a copy of this code header and (if applicable)
*                               a notation in the "About" page of your product.
*
*/

#include <inttypes.h>

#include "displaymanagement.h"
#include "libinterface.h"
#include "ui.h"
#include "driver/lcd/lcd_driver.h"

#include "debug.h"

volatile dm_source  src = 0;
volatile uint8_t    key = 0, state = 0;


void dm_refreshLcd(void){
    char       cTmp[lcdSize*2];
    uint8_t    len = 0, i = 0;

    if(src == 0){
        return;
    }

    key = ui_get_keystate();

    while((key != uik_no) && (i < 20)){
        (*src)((char *) 0, &len, lcdSize, key);
        key = ui_get_keystate();
        i++;
    }

    (*src)(cTmp, &len, lcdSize, key);

    ifWrite(lcdiface, 1, if_TODTP cTmp, len);

}

void    dm_newKey(uint8_t k){
    key = k;
}

void    dm_changeSource(dm_source sc){

    if(sc == 0){
        return;
    }

    src = sc;
}

void    dm_statemachine(uint8_t key){

    switch(state){


    }

}

