

/*
-------------------------------------------------------
    Interface - A simple hardware abstraction library

    by Tobias Schlegel - www.tobias-schlegel.de
-------------------------------------------------------

Copyright (C) 2010  Tobias Schlegel,
                    tobias@drschlegel.de
                    www.tobias-schlegel.de

Report bugs to:     tobias@drschlegel.de

This program is free software; you can redistribute it and/or modify it under the terms of the GNU
General Public License as published by the Free Software Foundation; either version 3 of the License,
or any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program; if not, see <http://www.gnu.org/licenses/>.
*/

/*
This is an excample of a standard driver.
*/

#include <avr/io.h>

#include "../../libinterface.h"

//LCD driver control commands
#define lcdc_shutdown        0 ///      shuts the lcd down
#define lcdc_init            1 ///   initializes LCD
#define lcdc_clear           2 ///   clears LCD
#define lcdc_goto            3 ///   jumps to xy coordinate


//LCD-init-Command attributes
#define lcda_on              0x0C   /* display on, cursor off                 */
#define lcda_on_blink        0x0D   /* display on, cursor off, blink char     */
#define lcda_on_cursor       0x0E   /* display on, cursor on                  */
#define lcda_on_cursor_blink 0x0F   /* display on, cursor on, blink char      */

uint8_t lcd_write(uint16_t, if_datatype *, uint8_t);
uint8_t lcd_read(uint16_t, if_datatype *, uint8_t);
uint8_t lcd_control(uint16_t, if_datatype *);
