
/*
*   libPWM
*   Simple multichannel 8Bit Soft-PWM library
*
*   File: libPWM.h
*
*   Version:    1.0beta
*   Author:     Tobias Schlegel, DK7SCH
*   Web:        www.tobias-schlegel.de
*   Contact:    tobias@drschlegel.de
*   Date:       5.Jan.2011
*   License:    Creative Commons CC-BY 3.0
*               http://creativecommons.org/licenses/by/3.0/deed.en
*
*               Attribution:    Attribute with a copy of this code header and (if applicable)
*                               a notation in the "About" page of your product.
*
*/

#include <avr/io.h>

#define PWMchannels 4
#define PWMprts {&PORTB, &PORTB, &PORTB, &PORTB}
#define PWMpns  {0,      1,      2,      3}

#define PwmTimerCountRegister TCNT0

void PWM_ISR(void);

void PWM_SetValue(uint8_t channel, uint8_t value);
void init_PWM(void);
