/*
*   Hot air controller
*   Controller for a hot air soldering gun
*
*   File: uart.h
*
*   Version:    1.0 beta (06.03.2011)
*   Author:     Tobias Schlegel, DK7SCH
*   Web:        www.tobias-schlegel.de
*   Contact:    tobias@drschlegel.de
*   Date:       06.03.2011
*   License:    Creative Commons CC-BY 3.0
*               http://creativecommons.org/licenses/by/3.0/deed.en
*
*               Attribution:    Attribute with a copy of this code header and (if applicable)
*                               a notation in the "About" page of your product.
*
*/


extern uint8_t uartstate;						//UART Statusvariable


uint8_t init_uart(uint16_t);

uint8_t uart_tx_ready(void);

uint8_t uart_rx_ready(void);

uint8_t uart_putcs(const char *, uint8_t);

uint8_t uart_puts(const char *);

uint8_t uart_putc(uint8_t );

uint8_t uart_getc(void);

uint8_t uart_getstate(void);

uint8_t uart_gets(volatile char *, uint8_t);

uint8_t uart_put_array(uint8_t *, uint8_t);
