

/*
-------------------------------------------------------
    Interface - A simple hardware abstraction library

    by Tobias Schlegel - www.tobias-schlegel.de
-------------------------------------------------------

Copyright (C) 2010  Tobias Schlegel,
                    tobias@drschlegel.de
                    www.tobias-schlegel.de

Report bugs to:     tobias@drschlegel.de

This program is free software; you can redistribute it and/or modify it under the terms of the GNU
General Public License as published by the Free Software Foundation; either version 3 of the License,
or any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program; if not, see <http://www.gnu.org/licenses/>.
*/

/*
This is an excample of a standard driver.
*/

#include <avr/io.h>

#include "../../libinterface.h"

#define uart_fifo_size  25

#define uartc_init          1
#define uartc_shutdown      0

#define uartc_newline       100


//uart driver errors
#define uarte_IO_underrun   1

//uart driver warnings
#define uartw_RequestUnderrun 128

uint8_t uart_write(uint16_t, if_datatype *, uint8_t);
uint8_t uart_read(uint16_t, if_datatype *, uint8_t);
uint8_t uart_control(uint16_t, if_datatype *);
