/*
*   Hot air controller
*   Controller for a hot air soldering gun
*
*   File: dynwatches.h
*
*   Version:    1.0 beta (06.03.2011)
*   Author:     Tobias Schlegel, DK7SCH
*   Web:        www.tobias-schlegel.de
*   Contact:    tobias@drschlegel.de
*   Date:       06.03.2011
*   License:    Creative Commons CC-BY 3.0
*               http://creativecommons.org/licenses/by/3.0/deed.en
*
*               Attribution:    Attribute with a copy of this code header and (if applicable)
*                               a notation in the "About" page of your product.
*
*/

#include <inttypes.h>


#ifndef _def_watch_once
#define _def_watch_once 1
struct watch{
    uint16_t    w;
    uint8_t     pre;
    uint8_t     p;
};

typedef struct watch * watchhandle;
#endif

watchhandle new_watch(uint8_t prescaler);
void w_reset_watch(watchhandle watch);
uint16_t get_watch(watchhandle watch);
uint8_t delete_watch(watchhandle watch);
uint16_t * get_watch_pointer(watchhandle watch);
void w_tick_watch(void);

