
/*
*   EZmalloc
*   An easy way to implement dynamic memory allocation into your (microcontroller) project
*   with no need to alter linker scripts or similar.
*
*   File: ezmalloc.h
*
*   Version:    1.1 beta (20.Feb.2011)
*   Author:     Tobias Schlegel, DK7SCH
*   Web:        www.tobias-schlegel.de
*   Contact:    tobias@drschlegel.de
*   Date:       20.Feb.2011
*   License:    Creative Commons CC-BY 3.0
*               http://creativecommons.org/licenses/by/3.0/deed.en
*
*               Attribution:    Attribute with a copy of this code header and (if applicable)
*                               a notation in the "About" page of your product.
*
*/

#include <inttypes.h>

#define memory_size     512 //in byte

#define NUL             (void *) 0


void init_memory(void); //initialize memory
void * malloc(uint16_t size); //usage as known
uint8_t delete(void * ptr); //instead of free()
void * calloc(void * ptr, uint16_t newsize); //useage as known

