/*
*   Hot air controller
*   Controller for a hot air soldering gun
*
*   File: libInput.h
*
*   Version:    1.0 beta (06.03.2011)
*   Author:     Tobias Schlegel, DK7SCH
*   Web:        www.tobias-schlegel.de
*   Contact:    tobias@drschlegel.de
*   Date:       06.03.2011
*   License:    Creative Commons CC-BY 3.0
*               http://creativecommons.org/licenses/by/3.0/deed.en
*
*               Attribution:    Attribute with a copy of this code header and (if applicable)
*                               a notation in the "About" page of your product.
*
*/

#include <inttypes.h>

#include "string.h"


#define inKey_plus      0x01
#define inKey_minus     0x02
#define inKey_plusFast  0x05
#define inKey_minusFast 0x06
#define inKey_enter     0x81
#define inKey_abort     0x24
#define inKey_OK        0x14


#define inR_Aborted     1
#define inR_Complete    2
#define inR_NOP         0


uint8_t inUI16(char *cOut, uint8_t * len, char * cTitle, char * cUnit, uint8_t key, uint16_t * value, uint8_t fraction, uint8_t step, uint8_t faststep);
uint8_t inI8(char *cOut, uint8_t * len, char * cTitle, char * cUnit, uint8_t key, int8_t * value, uint8_t fraction, uint8_t step, uint8_t faststep);
uint8_t inRlg10(uint16_t n);
