
/*
*   LibInterface
*   A very basic hardware abstraction library.
*   -> Type definition file
*
*   File: libinterface_types.c
*
*   Version:    1.0
*   File-Ver.:  1.0 (05.Jan.2011)
*   Author:     Tobias Schlegel, DK7SCH
*   Web:        www.tobias-schlegel.de
*   Contact:    tobias@drschlegel.de
*   Date:       5.Jan.2011
*   License:    Creative Commons CC-BY 3.0
*               http://creativecommons.org/licenses/by/3.0/deed.en
*
*               Attribution:    Attribute with a copy of this code header and (if applicable)
*                               a notation in the "About" page of your product.
*
*/

#include <inttypes.h>

#define if_datatype    uint8_t
#define if_TODT          (if_datatype)
#define if_TODTP        (if_datatype *)

#ifndef ifonce
#define ifonce 1

typedef uint8_t (*if_write)(uint16_t, if_datatype *, uint8_t);
typedef uint8_t (*if_read) (uint16_t, if_datatype *, uint8_t);
typedef uint8_t (*if_control)(uint16_t, if_datatype *);

typedef struct {
        uint8_t         Conf;
        uint8_t         Id;
        uint16_t        Address;
        uint8_t         TargetSize;
        if_datatype   * Target;
        if_write        Write;
        if_read         Read;
        if_control      Control;
    }iface;

#endif
