/*
*   Hot air controller
*   Controller for a hot air soldering gun
*
*   File: main.c
*
*   Version:    1.0 beta (06.03.2011)
*   Author:     Tobias Schlegel, DK7SCH
*   Web:        www.tobias-schlegel.de
*   Contact:    tobias@drschlegel.de
*   Date:       06.03.2011
*   License:    Creative Commons CC-BY 3.0
*               http://creativecommons.org/licenses/by/3.0/deed.en
*
*               Attribution:    Attribute with a copy of this code header and (if applicable)
*                               a notation in the "About" page of your product.
*
*/

#include <avr/io.h>

#include <util/delay.h>

#include "ui.h"
#include "init.h"

#include "namesaliases.h"
#include "libinterface.h"
#include "system.h"
#include "scheduler.h"

#include "UiFuncs.h"
#include "displaymanagement.h"
#include "events.h"
#include "pid.h"

#include "settings.h"

extern PIDdata regs[regulator_amount];

int main(void){

    init_avr();
    sys_init();

    dm_changeSource(uifSysView);


    while(1){ //main loop
        sh_buffered();
    }

    while(1);

    return 0;
}
