/*
*   Hot air controller
*   Controller for a hot air soldering gun
*
*   File: menuhandlers.c
*
*   Version:    1.0 beta (06.03.2011)
*   Author:     Tobias Schlegel, DK7SCH
*   Web:        www.tobias-schlegel.de
*   Contact:    tobias@drschlegel.de
*   Date:       06.03.2011
*   License:    Creative Commons CC-BY 3.0
*               http://creativecommons.org/licenses/by/3.0/deed.en
*
*               Attribution:    Attribute with a copy of this code header and (if applicable)
*                               a notation in the "About" page of your product.
*
*/

#include <inttypes.h>

#include "menuhandlers.h"

#include "system.h"
#include "settings.h"
#include "libinterface.h"
#include "namesaliases.h"
#include "libinput.h"

#include "displaymanagement.h"
#include "UiFuncs.h"

extern uint16_t temp;
extern int8_t  pidIn;
extern uint8_t pidinstat;

void mh_ChSetpnt(uint8_t call){

    temp = (Descriptors[call].regulator)->setpoint;
    dm_changeSource(uifSettemp);
}

void mh_BackSysScr(uint8_t call){
    dm_changeSource(uifSysView);
}

void mh_ChP(uint8_t call){
    pidIn = (Descriptors[call].regulator)->pPart;
    pidinstat = 1;
    dm_changeSource(uifSetPid);
}

void mh_ChI(uint8_t call){
    pidIn = (Descriptors[call].regulator)->iPart;
    pidinstat = 2;
    dm_changeSource(uifSetPid);
    }

void mh_ChD(uint8_t call){
    pidIn = (Descriptors[call].regulator)->dPart;
    pidinstat = 3;
    dm_changeSource(uifSetPid);
    }

void mm_facRes(uint8_t call){
    uint8_t i = 0;

    for(i = 0 ; i < regulator_amount ; i++){
        store_byte_setting(&(set_PidParams[i][0]), 70);
        store_byte_setting(&(set_PidParams[i][1]), 20);
        store_byte_setting(&(set_PidParams[i][2]), 20);
        store_word_setting(&(set_HeatSetpoints[i]), 1500);
    }

    dm_changeSource(uifSysView);
}


