/*
*   Hot air controller
*   Controller for a hot air soldering gun
*
*   File: pid.h
*
*   Version:    1.0 beta (06.03.2011)
*   Author:     Tobias Schlegel, DK7SCH
*   Web:        www.tobias-schlegel.de
*   Contact:    tobias@drschlegel.de
*   Date:       06.03.2011
*   License:    Creative Commons CC-BY 3.0
*               http://creativecommons.org/licenses/by/3.0/deed.en
*
*               Attribution:    Attribute with a copy of this code header and (if applicable)
*                               a notation in the "About" page of your product.
*
*/

#include <inttypes.h>


#ifndef __pid_regler
#define __pid_regler 1
typedef struct _regler{

    int16_t pPart;
    int16_t iPart;
    int16_t dPart;

    int16_t setpoint;

    int32_t INT;
    int16_t lastE;

}PIDdata;
#endif

uint8_t MkPID(PIDdata * piddata, int16_t Kp, int16_t Ki, int16_t Kd, int16_t setpoint);
int32_t PID(PIDdata* piddata, int16_t is);
void setSetpoint(PIDdata * piddata, int16_t setpnt);
void ResetPID(PIDdata * piddata);
