/*
*   Hot air controller
*   Controller for a hot air soldering gun
*
*   File: settings.c
*
*   Version:    1.0 beta (06.03.2011)
*   Author:     Tobias Schlegel, DK7SCH
*   Web:        www.tobias-schlegel.de
*   Contact:    tobias@drschlegel.de
*   Date:       06.03.2011
*   License:    Creative Commons CC-BY 3.0
*               http://creativecommons.org/licenses/by/3.0/deed.en
*
*               Attribution:    Attribute with a copy of this code header and (if applicable)
*                               a notation in the "About" page of your product.
*
*/

#include <avr/io.h>
#include <avr/eeprom.h>

#include "settings.h"
#include "namesaliases.h"

//eeprom hex file map
uint16_t    EEMEM set_HeatSetpoints[regulator_amount];
int8_t      EEMEM set_PidParams[regulator_amount][3];

uint8_t load_byte_setting(void * adr){
    return eeprom_read_byte((uint8_t *) adr);
}

void store_byte_setting(void * adr, uint8_t byte){
    eeprom_write_byte((uint8_t *) adr, byte);
}


uint16_t load_word_setting(void * adr){
    return eeprom_read_word((uint16_t *) adr);
}

void store_word_setting(void * adr, uint16_t word){
    eeprom_write_word((uint16_t *) adr, word);
}

