/*
*   Hot air controller
*   Controller for a hot air soldering gun
*
*   File: string.c
*
*   Version:    1.0 beta (06.03.2011)
*   Author:     Tobias Schlegel, DK7SCH
*   Web:        www.tobias-schlegel.de
*   Contact:    tobias@drschlegel.de
*   Date:       06.03.2011
*   License:    Creative Commons CC-BY 3.0
*               http://creativecommons.org/licenses/by/3.0/deed.en
*
*               Attribution:    Attribute with a copy of this code header and (if applicable)
*                               a notation in the "About" page of your product.
*
*/


#include <avr/io.h>
#include "string.h"

//collection of most often used string funcitons, simplified and ported

void sinttostr32(char * target, int32_t source, uint8_t digits){
	uint8_t		i = 0;
	uint8_t		position = 0;
	uint8_t		num = 0;

    position = digits;

    if(source < 0){
        target[0] = '-';
    }else{
        position -= 1;
    }

	for(i = 0 ; i < digits ; i++){

		num = source % 10;
		source /= 10;

		target[position] = (48 + num);

		position--;

	}

	target[digits] = 0;

}

void inttostr32(char * target, uint32_t source, uint8_t digits){
	uint8_t		i = 0;
	uint8_t		position = 0;
	uint8_t		num = 0;

	position = digits - 1;

	for(i = 0 ; i < digits ; i++){

		num = source % 10;
		source /= 10;

		target[position] = (48 + num);

		position--;

	}

	target[digits] = 0;

}

void sinttostr16(char * target, int16_t source, uint8_t digits){
	uint8_t		i = 0;
	uint8_t		position = 0;
	uint8_t		num = 0;

    position = digits;

    if(source < 0){
        target[0] = '-';
    }else{
        position -= 1;
    }

	for(i = 0 ; i < digits ; i++){

		num = source % 10;
		source /= 10;

		target[position] = (48 + num);

		position--;

	}

	target[digits] = 0;

}

void inttostr16(char * target, uint16_t source, uint8_t digits){
	uint8_t		i = 0;
	uint8_t		position = 0;
	uint8_t		num = 0;

	position = digits - 1;

	for(i = 0 ; i < digits ; i++){

		num = source % 10;
		source /= 10;

		target[position] = (48 + num);

		position--;

	}

	target[digits] = 0;

}


void sinttostr8(char * target, int8_t source, uint8_t digits){
	uint8_t		i = 0;
	uint8_t		position = 0;
	uint8_t		num = 0;

    position = digits;

    if(source < 0){
        target[0] = '-';
    }else{
        position -= 1;
    }

	for(i = 0 ; i < digits ; i++){

		num = source % 10;
		source /= 10;

		target[position] = (48 + num);

		position--;

	}

	target[digits] = 0;

}

void inttostr8(char * target, uint8_t source, uint8_t digits){
	uint8_t		i = 0;
	uint8_t		position = 0;
	uint8_t		num = 0;

	position = digits - 1;

	for(i = 0 ; i < digits ; i++){

		num = source % 10;
		source /= 10;

		target[position] = (48 + num);

		position--;

	}

	target[digits] = 0;

}


void str_cpy_p(char * t, const char * text){
    uint8_t i = 0, j = 0;

    j = str_len(t);

    for(i = 0 ; i < j+1 ; i++){
        t[i] = (char) text[i];
    }

    t[j+1] = (char) 0;
}


void str_cpy(char * t, char * text){
    uint8_t i = 0, j = 0;

    j = str_len(t);

    for(i = 0 ; i < j+1 ; i++){
        t[i] = (char) text[i];
    }

    t[j+1] = (char) 0;
}


void str_cat(char * a, char * b){
    uint8_t     i = 0, j = 0;

    j = str_len(a);

    for(i = 0 ; i < 255 ; i++){
        if(b[i] != (char) 0){
            a[j] = b[i];
            j++;
        }else{
            break;
        }
    }

    a[j] = (char) 0;
}


void str_cat_p(char * a, const char * b){
    uint8_t     i = 0, j = 0;

    j = str_len(a);

    for(i = 0 ; i < 255 ; i++){
        if(b[i] != (char) 0){
            a[j] = b[i];
            j++;
        }else{
            break;
        }
    }

    a[j] = (char) 0;
}


uint8_t str_len(char * t){
    uint8_t i = 0;

    for(i = 0 ; i < 255 ; i++){
        if(t[i] == (char) 0){
            return i;
        }
    }

    return 0;
}
