

#include "watches.h"

volatile uint16_t   watches[8];
volatile uint8_t    prescaler[8][2];
volatile uint8_t    watches_control;


void init_watches(void){

    uint8_t i = 0;

    watches_control = 0;

    for(i = 0 ; i < 8 ; i++){
        watches[i] = 0;
        prescaler[i][0] = 1;
        prescaler[i][1] = 0;
    }
}

void w_start_watch(uint8_t watchid, uint8_t pre){  //start and reset a watch

    watchid--;

    if(pre == 0){
        pre = 1;
    }

    watches_control |= (1<<watchid);
    prescaler[watchid][0] = pre;
    prescaler[watchid][1] = 0;
    watches[watchid] = 0;
}

void w_stop_watch(uint8_t watchid){   //stop a watch

    watchid--;

    watches_control &= ~(1<<watchid);
}

void w_reset_watch(uint8_t watchid){   //reset a watch

    watchid--;

    watches[watchid] = 0;
}

uint16_t get_watch(uint8_t watchid){

    watchid--;

    return watches[watchid];
}

uint16_t * get_watch_pointer(uint8_t watchid){

    watchid--;

    return (uint16_t *) &watches[watchid];
}

void w_tick_watch(void){
    uint8_t     i = 0;


    for(i = 0 ; i < 8 ; i++){

        if(watches_control & (1<<i)){

            prescaler[i][1]++;

            if(prescaler[i][0] == prescaler[i][1]){
                watches[i]++;
                prescaler[i][1] = 0;
            }
        }
    }
}
